//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------

#ifndef GLES20STD_FS
#define GLES20STD_FS

#ifdef FRAGMENT_SHADER

vec3 unpackNormal(sampler2D texture, vec2 coords) {
    vec3 N = normalize(varNormal);
    vec3 T = normalize(varTangent);
    vec3 B = normalize(cross(varNormal, varTangent) * varBitangentSign);
    mat3 TBN = mat3(T, B, N);
    vec3 nm = texture2D(texture, coords).xyz * 2.0 - vec3(1.0);
    return normalize(TBN * normalize(nm));
}

vec4 getFramebufferColor() {
#ifdef sc_FramebufferFetch

    #if defined(GL_EXT_shader_framebuffer_fetch)
        return gl_LastFragData[0].rgba;
    #elif defined(GL_ARM_shader_framebuffer_fetch)
        return gl_LastFragColorARM;
    #else
        #error sc_FramebufferFetch but no ext found!
    #endif

#else

    return texture2D(sc_ScreenTexture, varScreenPos.xy / varScreenPos.w * 0.5 + 0.5).rgba;

#endif
}

#endif //FRAGMENT_SHADER


#endif //GLES20STD_FS
