//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------
#include <required.glsl>

uniform sampler2D texture;
uniform vec4 color;
uniform mat3 textureTransform;

varying vec2 varTex0;

#ifdef VERTEX_SHADER
attribute vec2 position;
attribute vec2 texture0;

void main(void) {
    varTex0 = vec2(textureTransform * vec3(texture0, 1.0));
    gl_Position = vec4(position, 0.0, 1.0);
}
#endif

#ifdef FRAGMENT_SHADER
void main(void) {
    vec4 diffuse = texture2D(texture, varTex0);
    gl_FragColor = color * diffuse;
}
#endif
