//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------

uniform sampler2D texture;
uniform vec2 scale;
uniform vec2 offset;

varying vec2 varTex0;

#ifdef VERTEX_SHADER
attribute vec2 position;
attribute vec2 texture0;

void main(void) {
    varTex0 = (texture0 + offset) * scale;
    gl_Position = vec4(position, 0.0, 1.0);
}
#endif

#ifdef FRAGMENT_SHADER
void main(void) {
    if(varTex0.x < 0.0 || varTex0.x > 1.0 || varTex0.y < 0.0 || varTex0.y > 1.0)
    {
        discard;
    }
    float alpha = texture2D(texture, varTex0).r;
    float color = 1.0;
#ifdef R
    gl_FragColor = vec4(alpha, 0.0, 0.0, 0.0);
#elif defined(RG)
    gl_FragColor = vec4(color, alpha, 0.0, 0.0);
#elif defined(RGBA)
    gl_FragColor = vec4(color, color, color, alpha);
#endif
}
#endif
