//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------
#ifndef LIGHTING_GLSL
#define LIGHTING_GLSL

// TODO: refactor to make this include usable
//#include "spherical_harmonics.glsl"

#ifdef sc_AmbientLightsCount
// TODO: remove after refactoring "spherical_harmonics.glsl"
vec3 evaluateSh(vec3 L00, vec3 L1_1, vec3 L10, vec3 L11, vec3 L2_2, vec3 L2_1, vec3 L20, vec3 L21, vec3 L22, vec3 n) {
    float x, y, z, x2, y2, z2, xy, yz, xz;
    
    const float c1 = 0.429043 ;
    const float c2 = 0.511664 ;
    const float c3 = 0.743125 ;
    const float c4 = 0.886227 ;
    const float c5 = 0.247708 ;
    x = n[0] ; y = n[1] ; z = n[2] ;
    
    x2 = x*x ; y2 = y*y ; z2 = z*z ;
    xy = x*y ; yz = y*z ; xz = x*z ;
    
    return c1*L22*(x2-y2) + c3*L20*z2 + c4*L00 - c5*L20
    + 2.0*c1*(L2_2*xy + L21*xz + L2_1*yz)
    + 2.0*c2*(L11*x+L1_1*y+L10*z) ;
}

vec4 getAmbientDiffusePerLight(vec3 normal, int lightIndex, int lightMode){
    vec4 result = vec4(0.0);
    
    if (lightMode == sc_AmbientLightMode_Constant) {
        result += vec4(sc_AmbientLights[lightIndex].color * sc_AmbientLights[lightIndex].intensity, 1.0);
    }
    if (lightMode == sc_AmbientLightMode_SphericalHarmonics) {
        normal = -normal;
        result += vec4(evaluateSh(
                       sc_AmbientLights[lightIndex].sphericalHarmonics[0],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[1],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[2],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[3],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[4],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[5],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[6],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[7],
                       sc_AmbientLights[lightIndex].sphericalHarmonics[8], normal), 1.0);
        
        result *= sc_AmbientLights[lightIndex].intensity;
    }
    if (lightMode == sc_AmbientLightMode_EnvironmentMap) {
        result += vec4(0.0);
    }
    
    return result * sc_AmbientLights[lightIndex].weight;
}

vec4 getAmbientSpecularPerLight(vec3 dir, int lightIndex, int lightMode){
    vec4 result = vec4(0.0);
    
    if (lightMode == sc_AmbientLightMode_EnvironmentMap) {
        result += vec4(0.0);
    }
    
    return result * sc_AmbientLights[lightIndex].weight;
}
#endif

vec4 getAmbientDiffuseLight(vec3 normal){
    vec4 accumulatedLight = vec4(0.0);
    
#ifdef sc_AmbientLightsCount
#if sc_AmbientLightsCount > 0
    accumulatedLight += getAmbientDiffusePerLight(normal, 0, sc_AmbientLightMode0);
#endif
#if sc_AmbientLightsCount > 1
    accumulatedLight += getAmbientDiffusePerLight(normal, 1, sc_AmbientLightMode1);
#endif
#if sc_AmbientLightsCount > 2
    accumulatedLight += getAmbientDiffusePerLight(normal, 2, sc_AmbientLightMode2);
#endif
#endif

    return accumulatedLight;
}

vec4 getAmbientSpecularLight(vec3 dir){
    vec4 accumulatedLight = vec4(0.0);
    
#ifdef sc_AmbientLightsCount
#if sc_AmbientLightsCount > 0
    accumulatedLight += getAmbientSpecularPerLight(dir, 0, sc_AmbientLightMode0);
#endif
#if sc_AmbientLightsCount > 1
    accumulatedLight += getAmbientSpecularPerLight(dir, 1, sc_AmbientLightMode1);
#endif
#if sc_AmbientLightsCount > 2
    accumulatedLight += getAmbientSpecularPerLight(dir, 2, sc_AmbientLightMode2);
#endif
#endif

    return accumulatedLight;
}

#endif //LIGHTING_GLSL
