#include <std.glsl>
#include <std_vs.glsl>
#include <std_fs.glsl>

uniform vec2 uniFreq;
uniform vec2 uniAmpl;

varying vec2 coords;

#ifdef VERTEX_SHADER

void sc_VSMain(inout sc_Vertex_t vertex) {
    vec4 screenPosition = sc_ObjectToScreen(vertex.position);
    coords = screenPosition.xy / screenPosition.w * 0.5 + 0.5;
}

#endif //VERTEX_SHADER



#ifdef FRAGMENT_SHADER

void main(void)
{
	vec2 dt = vec2(0.0, 0.0);
	dt.x = sin(sc_TimeElapsed * uniFreq.x * 10.0) * uniAmpl.x / 100.0;
	dt.y = cos(sc_TimeElapsed * uniFreq.y * 10.0) * uniAmpl.y / 100.0;

	gl_FragColor = texture2D(sc_ScreenTexture, coords + dt);
}

#endif //FRAGMENT_SHADER
