#include <std.glsl>
#include <std_vs.glsl>
#include <std_fs.glsl>

//1.0 - 100% zoom
//2.0 - 200% zoom
uniform float uniZoom;

varying vec2 coords;

#ifdef VERTEX_SHADER

void sc_VSMain(inout sc_Vertex_t vertex) {
    vec4 screenPosition = sc_ObjectToScreen(vertex.position);
    coords = (screenPosition.xy / uniZoom) / screenPosition.w * 0.5 + 0.5;
}

#endif //VERTEX_SHADER



#ifdef FRAGMENT_SHADER

void main()
{
	gl_FragColor = texture2D(sc_ScreenTexture, coords);
}

#endif //FRAGMENT_SHADER
