#version 100
#extension GL_OES_EGL_image_external : require

precision mediump float;

varying vec2 vTexCoord;

#if defined (EXTERNAL_OES_VIDEO_TEXTURE)
uniform samplerExternalOES sVideoTexture;
#elif defined (TEXTURE_2D_VIDEO_TEXTURE)
uniform sampler2D sVideoTexture;
#endif

uniform float uRadius;
uniform float uStep;
uniform vec4 uCircleColor;

void main()
{
    vec2 texCoord = vTexCoord - vec2(0.5);
    float d = distance(texCoord, vec2(0.0));
    float dfdx = distance(texCoord + vec2(uStep,0.0), vec2(0.0)) - d;
    float dfdy = distance(texCoord + vec2(0.0,uStep), vec2(0.0)) - d;
    float fwidth = abs(dfdx) + abs(dfdy);
    float circle = 0.5 * uRadius;
    float alpha = smoothstep(circle - fwidth, circle, d);
    vec2 scaled = texCoord / uRadius + vec2(0.5);
    gl_FragColor = mix(texture2D(sVideoTexture, scaled), uCircleColor, alpha);
}